Attribute VB_Name = "mPaths"
Option Explicit

Public oSquares As cSquares
Public nDiagonalMultiplyer As Single
Public nHeightDifference As Long

' Main procedure: Initialize, display form, cleanup after termination
Sub Main()

    ' Initialize program
    Call AppInit
    
    ' Display main form
    fPaths.Show 1
    
    ' Cleanup and exit
    Call AppExit
    
End Sub

' Program initialization: Create map structure, initialize variables
Sub AppInit()

    ' Create squares collection to store map
    Set oSquares = New cSquares
    
    ' Initialize map (40x40)
    Dim nRun As Integer
    For nRun = 0 To 1599
        oSquares.Add 1
    Next
    
    ' Set start and destination square
    oSquares.Item(810).SquareType = stStart
    oSquares.Item(830).SquareType = stDestination
    
    ' Set initial conditions
    nDiagonalMultiplyer = 2
    nHeightDifference = 5
    
End Sub

' Program termination: Clean up, reset all objects
Sub AppExit()

    ' Release the map square collection
    Set oSquares = Nothing
    
End Sub

' Pathfinder: Call the algorithm currently selected
Function FindPath(nIndex As Integer) As Double

    ' Initialize state of the squares
    Dim nRun As Integer
    For nRun = 0 To oSquares.Count - 1
        oSquares.Item(nRun).Pathstate = psNone
    Next
    oSquares.Redraw
    
    ' Record time ellapsed
    Dim nTime As Double
    nTime = Timer
    
    Select Case nIndex
            
        ' Breath search
        Case 0
            Call A_Breath
            
        ' Dijkstra
        Case 1
            Call A_Dijkstra
            
        ' A -star
        Case 2
            Call A_Astar
            
    End Select
    
    ' Return time ellapsed
    FindPath = Timer - nTime
    
End Function
